<template>
  <ContentWrapper>
    <div class="content-heading">
      <div>Relação de permissões
        <ol class="breadcrumb breadcrumb px-0 pb-0">
          <li class="breadcrumb-item active">
            <a href="/permissions" @click.prevent="$router.push({path:'/permissions'})">Permissões</a>
          </li>
        </ol>
      </div>
    </div>
    <div class="card">
      <!-- <div class="card-header">
        <div class="card-title">Relação de permissões</div>
        <div class="text-sm"></div>
      </div>-->
      <div :class="'card-body'">
        <Datatable
          v-if="!process"
          :options="dtOptions"
          class="table table-striped my-4 w-100"
          id="datatable"
        >
          <thead>
            <tr>
              <th data-priority="1">#</th>
              <th>Nome</th>
              <th>Permissão</th>
              <th>Ações</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="permission in permissions" :key="permission.id">
              <td>{{permission.id}}</td>
              <td>{{permission.name}}</td>
              <td>{{permission.readable_name}}</td>
              <td>
                <div class="btn-group">
                  <button class="btn btn-info btn-sm" type="button" @click="edit(permission)">
                    <em style="padding:5px" class="fas fa-user-edit"></em>
                  </button>
                  <button class="btn btn-danger btn-sm" type="button" @click="remove(permission)">
                    <em style="padding:5px" class="fas fa-user-alt-slash"></em>
                  </button>
                </div>
              </td>
            </tr>
          </tbody>
        </Datatable>
      </div>
    </div>
  </ContentWrapper>
</template>
<script>
import Datatable from "@/components/Tables/Datatable";
import Multiselect from "vue-multiselect";
import swal from "sweetalert2";

import Permission from "@/domain/permission/Permission";
import PermissionService from "@/domain/permission/PermissionService";

import NotificationProvider from "@/provider/NotificationProvider";

export default {
  name: "permission-list",
  components: {
    Datatable,
    Multiselect
  },
  created() {
    // buscando perfis
    this.process = true;
    this.permissionService
      .list(999, 1)
      .then(response => {
        this.permissions = response;
        this.process = false;
      })
      .catch(err => {
        console.log(JSON.stringify(err));
        this.notificationProvider.error(
          "Falha na comunicação",
          "Não foi possível listar as permissões"
        );
      });
  },
  data() {
    return {
      process: false,
      permissionService: new PermissionService(),
      permissions: [],
      notificationProvider: new NotificationProvider(this.$notify),
      dtOptions: {
        paging: true, // Table pagination
        ordering: true, // Column ordering
        info: true, // Bottom left status text
        responsive: true,
        // Text translation options
        // Note the required keywords between underscores (e.g _MENU_)
        oLanguage: {
          sSearch: '<em class="fa fa-search"></em>',
          sLengthMenu: "_MENU_ registros por página",
          info: "Página _PAGE_ de _PAGES_",
          zeroRecords: "Nada encontrado",
          infoEmpty: "Nenhum registro",
          infoFiltered: "(Filtrado de _MAX_ itens)",
          oPaginate: {
            sNext: '<em class="fa fa-caret-right"></em>',
            sPrevious: '<em class="fa fa-caret-left"></em>'
          }
        },
        // Datatable key setup
        keys: false
      }
    };
  },
  methods: {
    remove(permission) {
      swal({
        title: "Deletar " + permission.name + "?",
        text: "Não será possível recuperar!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: "Sim, deletar!"
      }).then(result => {
        if (result.value) {
          this.permissionService
            .delete(permission.id)
            .then(response => {
              this.permissions.forEach((el, index) => {
                if (permission.id == el.id) {
                  this.permissions.splice(index, 1);
                }
              });
              this.notificationProvider.success(
                "Deletado",
                "Permissão " + permission.name + " deletada com sucesso!"
              );
            })
            .catch(err => {
              if (
                err.response &&
                err.response.data &&
                err.response.data.message &&
                err.response.data.message.indexOf(
                  "Integrity constraint violation"
                )
              ) {
                // erro de vinculo no banco
                this.notificationProvider.error(
                  "Não é possível remover",
                  "Existem registros vinculados a este registro"
                );
              } else {
                console.log(JSON.stringify(err));
                this.notificationProvider.error(
                  "Falha ao remover",
                  "Não foi possível remover este registro"
                );
              }
            });
        }
      });
    },
    edit(permission) {
      this.$router.push({
        path: "/permission/" + permission.id
      });
    }
  }
};
</script>